> For the complete documentation index, see [llms.txt](https://kerasnoone.gitbook.io/garnet/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://kerasnoone.gitbook.io/garnet/suan-fa/zhan/496-xia-yi-ge-geng-da-yuan-su-i.md).

# \[496]\[简单]\[栈] 下一个更大元素 I

## 题目描述

[496. 下一个更大元素 I](https://leetcode-cn.com/problems/next-greater-element-i/)

给你两个 没有重复元素 的数组 nums1 和 nums2 ，其中nums1 是 nums2 的子集。

请你找出 nums1 中每个元素在 nums2 中的下一个比其大的值。

nums1 中数字 x 的下一个更大元素是指 x 在 nums2 中对应位置的右边的第一个比 x 大的元素。如果不存在，对应位置输出 -1 。

示例 1:

```
输入: nums1 = [4,1,2], nums2 = [1,3,4,2].
输出: [-1,3,-1]
解释:
    对于 num1 中的数字 4 ，你无法在第二个数组中找到下一个更大的数字，因此输出 -1 。
    对于 num1 中的数字 1 ，第二个数组中数字1右边的下一个较大数字是 3 。
    对于 num1 中的数字 2 ，第二个数组中没有下一个更大的数字，因此输出 -1 。
```

示例 2:

```
输入: nums1 = [2,4], nums2 = [1,2,3,4].
输出: [3,-1]
解释:
    对于 num1 中的数字 2 ，第二个数组中的下一个较大数字是 3 。
    对于 num1 中的数字 4 ，第二个数组中没有下一个更大的数字，因此输出 -1 。
```

提示：

* 1 <= nums1.length <= nums2.length <= 1000
* 0 <= nums1\[i], nums2\[i] <= 104
* nums1和nums2中所有整数 互不相同
* nums1 中的所有整数同样出现在 nums2 中

进阶：你可以设计一个时间复杂度为 O(nums1.length + nums2.length) 的解决方案吗？

## 解题思路

我们可以先找到nums2中每个元素的下一个更大元素, 方法参考[\[503\]\[中等\]\[栈\] 下一个更大元素 II](/garnet/suan-fa/zhan/503-xia-yi-ge-geng-da-yuan-su-ii.md). 由于nums1和nums2中都没有重复元素, 因此可以建立一个哈希表, 记录nums2中每个元素对应的下一个最大元素值. 然后nums1中的每个数字去哈希表中找对应的答案即可.

```python
class Solution:
    def nextGreaterElement(self, nums1: List[int], nums2: List[int]) -> List[int]:
        greater = [-1] * len(nums2)
        stack = []
        for i in range(len(nums2)):
            while stack and nums2[stack[-1]] < nums2[i]:
                greater[stack.pop()] = nums2[i]
            stack.append(i)
        mapping = dict(zip(nums2, greater))
        return [mapping.get(num, -1) for num in nums1]
```
